#ifndef EFL_GENERATED_EFL_PLAYER_HH
#define EFL_GENERATED_EFL_PLAYER_HH

extern "C"
{
#include <Efl.h>
}
#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "efl_player.eo.h"
}


namespace efl {

struct player;

}

namespace eo_cxx {

namespace efl {

struct player
{
   /// @brief * @brief Get play/pause state of the media file.
   ///
   /// @param play true if playing, false otherwise.
   ///
   bool play_get() const;


   /// @brief * @brief Set play/pause state of the media file.
   /// *
   /// * This functions sets the currently playing status of the video. Using this
   /// * function to play or pause the video doesn't alter it's current position.
   ///
   /// @param play true if playing, false otherwise.
   ///
   void play_set(bool play_) const;


   /// @brief * @brief Get the position in the media file.
   /// *
   /// * @param obj The emotion object from which the position will be retrieved.
   /// * @return The position of the media file.
   /// *
   /// * The position is returned as the number of seconds since the beginning of the
   /// * media file.
   ///
   /// @param second The position (in seconds).
   ///
   double position_get() const;


   /// @brief * @brief Set the position in the media file.
   /// *
   /// * @param obj The emotion object whose position will be changed.
   /// * @param sec The position(in seconds) to which the media file will be set.
   /// *
   /// * This functions sets the current position of the media file to @p sec, this
   /// * only works on seekable streams. Setting the position doesn't change the
   /// * playing state of the media file.
   ///
   /// @param second The position (in seconds).
   ///
   void position_set(double second_) const;


   /// @brief * @brief Get how much of the file has been played.
   /// *
   /// * This function gets the progress in playing the file, the return value is in
   /// * the [0, 1] range.
   ///
   /// @param progress The progress within the [0, 1] range.
   ///
   double progress_get() const;


   /// @param speed The play speed in the [0, infinity) range.
   ///
   double play_speed_get() const;


   /// @param speed The play speed in the [0, infinity) range.
   ///
   void play_speed_set(double speed_) const;


   /// @param volume The volume level
   ///
   double audio_volume_get() const;


   /// @param volume The volume level
   ///
   void audio_volume_set(double volume_) const;


   /// @param mute The mute state. True or false.
   ///
   bool audio_mute_get() const;


   /// @param mute The mute state. True or false.
   ///
   void audio_mute_set(bool mute_) const;



   static Eo_Class const* _eo_class()
   {
      return(EFL_PLAYER_INTERFACE);
   }

   operator ::efl::player() const;
   operator ::efl::player&();
   operator ::efl::player const&() const;

   template <typename D>
   struct address_of
   {
      operator ::efl::player*() const { return static_cast<::efl::player*>(static_cast<D const*>(this)->p); }
      operator ::efl::player const*() const { return static_cast<::efl::player const*>(static_cast<D const*>(this)->p); }
   };

   template <typename D>
   struct address_const_of
   {
      operator ::efl::player const*() const { return static_cast<::efl::player const*>(static_cast<D const*>(this)->p); }
   };

private:
   Eo* _concrete_eo_ptr() const
   {
      return static_cast<::efl::eo::concrete const*>(static_cast<void const*>(this))->_eo_ptr();
   }

};

}

}

namespace efl {

struct player
      : ::efl::eo::concrete
{
   player(::efl::eo::parent_type _p = (::efl::eo::parent = nullptr))
      : player(_ctors_call(_p))
   {}

   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit player(Eo* eo)
      : ::efl::eo::concrete(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit player(std::nullptr_t)
      : ::efl::eo::concrete(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   player(player const& other)
      : player(eo_ref(other._eo_ptr()))
   {}

   ~player() {}

   /// @brief * @brief Get play/pause state of the media file.
   ///
   /// @param play true if playing, false otherwise.
   ///
   bool play_get() const;


   /// @brief * @brief Set play/pause state of the media file.
   /// *
   /// * This functions sets the currently playing status of the video. Using this
   /// * function to play or pause the video doesn't alter it's current position.
   ///
   /// @param play true if playing, false otherwise.
   ///
   void play_set(bool play_) const;


   /// @brief * @brief Get the position in the media file.
   /// *
   /// * @param obj The emotion object from which the position will be retrieved.
   /// * @return The position of the media file.
   /// *
   /// * The position is returned as the number of seconds since the beginning of the
   /// * media file.
   ///
   /// @param second The position (in seconds).
   ///
   double position_get() const;


   /// @brief * @brief Set the position in the media file.
   /// *
   /// * @param obj The emotion object whose position will be changed.
   /// * @param sec The position(in seconds) to which the media file will be set.
   /// *
   /// * This functions sets the current position of the media file to @p sec, this
   /// * only works on seekable streams. Setting the position doesn't change the
   /// * playing state of the media file.
   ///
   /// @param second The position (in seconds).
   ///
   void position_set(double second_) const;


   /// @brief * @brief Get how much of the file has been played.
   /// *
   /// * This function gets the progress in playing the file, the return value is in
   /// * the [0, 1] range.
   ///
   /// @param progress The progress within the [0, 1] range.
   ///
   double progress_get() const;


   /// @param speed The play speed in the [0, infinity) range.
   ///
   double play_speed_get() const;


   /// @param speed The play speed in the [0, infinity) range.
   ///
   void play_speed_set(double speed_) const;


   /// @param volume The volume level
   ///
   double audio_volume_get() const;


   /// @param volume The volume level
   ///
   void audio_volume_set(double volume_) const;


   /// @param mute The mute state. True or false.
   ///
   bool audio_mute_get() const;


   /// @param mute The mute state. True or false.
   ///
   void audio_mute_set(bool mute_) const;



   static Eo_Class const* _eo_class()
   {
      return(EFL_PLAYER_INTERFACE);
   }

   struct address_of
      : ::eo_cxx::efl::player::address_of<address_of>
      , ::efl::eo::detail::concrete_address_of
   {
      explicit address_of(::efl::player* p)
         : ::efl::eo::detail::concrete_address_of(p)
      {}
   };
   address_of operator&() { return address_of(this); }

   struct address_const_of
      : ::eo_cxx::efl::player::address_const_of<address_const_of>
      , ::efl::eo::detail::concrete_address_const_of
   {
      explicit address_const_of(::efl::player const* p)
         : ::efl::eo::detail::concrete_address_const_of(p)
      {}
   };
   address_const_of operator&() const { return address_const_of(this); }

private:
   static Eo* _ctors_call(::efl::eo::parent_type _p)
   {
      Eo* _ret_eo = eo_add_ref(EFL_PLAYER_INTERFACE, _p._eo_raw, );

      return _ret_eo;
   }

      Eo* _concrete_eo_ptr() const { return _eo_ptr(); }
};

static_assert(sizeof(::efl::player) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<::efl::player>::value, "");

}

inline bool efl::player::play_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::efl_player_play_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}


inline void efl::player::play_set(bool play_) const
{
   eo_do(_concrete_eo_ptr(), ::efl_player_play_set(::efl::eolian::to_c(play_)));
}


inline double efl::player::position_get() const
{
   double _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::efl_player_position_get());
   return _tmp_ret;
}


inline void efl::player::position_set(double second_) const
{
   eo_do(_concrete_eo_ptr(), ::efl_player_position_set(second_));
}


inline double efl::player::progress_get() const
{
   double _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::efl_player_progress_get());
   return _tmp_ret;
}


inline double efl::player::play_speed_get() const
{
   double _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::efl_player_play_speed_get());
   return _tmp_ret;
}


inline void efl::player::play_speed_set(double speed_) const
{
   eo_do(_concrete_eo_ptr(), ::efl_player_play_speed_set(speed_));
}


inline double efl::player::audio_volume_get() const
{
   double _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::efl_player_audio_volume_get());
   return _tmp_ret;
}


inline void efl::player::audio_volume_set(double volume_) const
{
   eo_do(_concrete_eo_ptr(), ::efl_player_audio_volume_set(volume_));
}


inline bool efl::player::audio_mute_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::efl_player_audio_mute_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}


inline void efl::player::audio_mute_set(bool mute_) const
{
   eo_do(_concrete_eo_ptr(), ::efl_player_audio_mute_set(::efl::eolian::to_c(mute_)));
}


inline bool eo_cxx::efl::player::play_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::efl_player_play_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}


inline void eo_cxx::efl::player::play_set(bool play_) const
{
   eo_do(_concrete_eo_ptr(), ::efl_player_play_set(::efl::eolian::to_c(play_)));
}


inline double eo_cxx::efl::player::position_get() const
{
   double _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::efl_player_position_get());
   return _tmp_ret;
}


inline void eo_cxx::efl::player::position_set(double second_) const
{
   eo_do(_concrete_eo_ptr(), ::efl_player_position_set(second_));
}


inline double eo_cxx::efl::player::progress_get() const
{
   double _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::efl_player_progress_get());
   return _tmp_ret;
}


inline double eo_cxx::efl::player::play_speed_get() const
{
   double _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::efl_player_play_speed_get());
   return _tmp_ret;
}


inline void eo_cxx::efl::player::play_speed_set(double speed_) const
{
   eo_do(_concrete_eo_ptr(), ::efl_player_play_speed_set(speed_));
}


inline double eo_cxx::efl::player::audio_volume_get() const
{
   double _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::efl_player_audio_volume_get());
   return _tmp_ret;
}


inline void eo_cxx::efl::player::audio_volume_set(double volume_) const
{
   eo_do(_concrete_eo_ptr(), ::efl_player_audio_volume_set(volume_));
}


inline bool eo_cxx::efl::player::audio_mute_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::efl_player_audio_mute_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}


inline void eo_cxx::efl::player::audio_mute_set(bool mute_) const
{
   eo_do(_concrete_eo_ptr(), ::efl_player_audio_mute_set(::efl::eolian::to_c(mute_)));
}


inline ::eo_cxx::efl::player::operator ::efl::player() const
{
   return *static_cast<::efl::player const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::efl::player::operator ::efl::player&()
{
   return *static_cast<::efl::player*>(static_cast<void*>(this));
}

inline ::eo_cxx::efl::player::operator ::efl::player const&() const
{
   return *static_cast<::efl::player const*>(static_cast<void const*>(this));
}

template <typename T>
bool efl_player_play_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   bool _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->play_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void efl_player_play_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool play_)
{
   try
      {
         static_cast<T*>(self->this_)->play_set(::efl::eolian::to_cxx<bool>(play_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
double efl_player_position_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   double _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->position_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void efl_player_position_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, double second_)
{
   try
      {
         static_cast<T*>(self->this_)->position_set(second_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
double efl_player_progress_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   double _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->progress_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
double efl_player_play_speed_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   double _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->play_speed_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void efl_player_play_speed_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, double speed_)
{
   try
      {
         static_cast<T*>(self->this_)->play_speed_set(speed_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
double efl_player_audio_volume_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   double _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->audio_volume_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void efl_player_audio_volume_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, double volume_)
{
   try
      {
         static_cast<T*>(self->this_)->audio_volume_set(volume_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool efl_player_audio_mute_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   bool _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->audio_mute_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
void efl_player_audio_mute_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool mute_)
{
   try
      {
         static_cast<T*>(self->this_)->audio_mute_set(::efl::eolian::to_cxx<bool>(mute_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::efl::player >
{
   template <typename T>
   struct type
   {
      virtual bool play_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::efl_player_play_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void play_set(bool play_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::efl_player_play_set(::efl::eolian::to_c(play_)));
      }

      virtual double position_get()
      {
         double _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::efl_player_position_get());
            return _tmp_ret;
      }

      virtual void position_set(double second_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::efl_player_position_set(second_));
      }

      virtual double progress_get()
      {
         double _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::efl_player_progress_get());
            return _tmp_ret;
      }

      virtual double play_speed_get()
      {
         double _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::efl_player_play_speed_get());
            return _tmp_ret;
      }

      virtual void play_speed_set(double speed_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::efl_player_play_speed_set(speed_));
      }

      virtual double audio_volume_get()
      {
         double _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::efl_player_audio_volume_get());
            return _tmp_ret;
      }

      virtual void audio_volume_set(double volume_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::efl_player_audio_volume_set(volume_));
      }

      virtual bool audio_mute_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::efl_player_audio_mute_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void audio_mute_set(bool mute_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::efl_player_audio_mute_set(::efl::eolian::to_c(mute_)));
      }

   };
};


template<>
struct operation_description_class_size< ::efl::player >
{
   static const int value = 11;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::efl::player>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::efl_player_play_get_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::efl_player_play_get);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::efl_player_play_set_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::efl_player_play_set);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::efl_player_position_get_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::efl_player_position_get);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::efl_player_position_set_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::efl_player_position_set);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::efl_player_progress_get_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::efl_player_progress_get);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::efl_player_play_speed_get_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::efl_player_play_speed_get);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   ops[6].func = reinterpret_cast<void*>(& ::efl_player_play_speed_set_wrapper<T>);
   ops[6].api_func = reinterpret_cast<void*>(& ::efl_player_play_speed_set);
   ops[6].op = EO_OP_OVERRIDE;
   ops[6].op_type = EO_OP_TYPE_REGULAR;
   ops[6].doc = NULL;

   ops[7].func = reinterpret_cast<void*>(& ::efl_player_audio_volume_get_wrapper<T>);
   ops[7].api_func = reinterpret_cast<void*>(& ::efl_player_audio_volume_get);
   ops[7].op = EO_OP_OVERRIDE;
   ops[7].op_type = EO_OP_TYPE_REGULAR;
   ops[7].doc = NULL;

   ops[8].func = reinterpret_cast<void*>(& ::efl_player_audio_volume_set_wrapper<T>);
   ops[8].api_func = reinterpret_cast<void*>(& ::efl_player_audio_volume_set);
   ops[8].op = EO_OP_OVERRIDE;
   ops[8].op_type = EO_OP_TYPE_REGULAR;
   ops[8].doc = NULL;

   ops[9].func = reinterpret_cast<void*>(& ::efl_player_audio_mute_get_wrapper<T>);
   ops[9].api_func = reinterpret_cast<void*>(& ::efl_player_audio_mute_get);
   ops[9].op = EO_OP_OVERRIDE;
   ops[9].op_type = EO_OP_TYPE_REGULAR;
   ops[9].doc = NULL;

   ops[10].func = reinterpret_cast<void*>(& ::efl_player_audio_mute_set_wrapper<T>);
   ops[10].api_func = reinterpret_cast<void*>(& ::efl_player_audio_mute_set);
   ops[10].op = EO_OP_OVERRIDE;
   ops[10].op_type = EO_OP_TYPE_REGULAR;
   ops[10].doc = NULL;

   return 0;
}
inline void
call_constructor(::efl::eo::detail::tag< ::efl::player >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               ::efl::eo::detail::args_class<::efl::player, ::std::tuple<::efl::eo::parent_type> > const& args)
{
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

inline Eo_Class const* get_eo_class(tag<::efl::player>)
{
   return (EFL_PLAYER_INTERFACE);
}

} } }
#endif // EFL_GENERATED_EFL_PLAYER_HH

